﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="BPMNShapes.aspx.cs" Inherits="WebApplication2.BPMNShapes" %>


<%@ Register Assembly="Syncfusion.EJ.Web" Namespace="Syncfusion.JavaScript" TagPrefix="ej" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <link href="ej/default-theme/ej.widgets.all.min.css" rel="stylesheet" />
    <link href="ej/default-theme/default-responsive.css" rel="stylesheet" />
    <script src="scripts/jquery-1.10.2.min.js"></script>
    <script src="Scripts/jquery.easing-1.3.min.js"></script>
    <script src="Scripts/jquery.globalize.min.js"></script>
    <script src="Scripts/jsrender.min.js"></script>
    <script src="Scripts/jimpatch/ej.web.all.js"></script>
    <style type="text/css">
        div.RadToolBar_Office2007 .rtbWrap /* toolbar buttons */ {
            font-size: 0px;
        }

        div.RadToolBarDropDown_Office2007 .rtbWrap /* toolbar drop-down items */ {
            font-size: 12px;
        }

        .rtbChoiceArrow {
            background-image: url("Images/Navvia/SplitButton-Down-Arrow-Wide.png") !important;
            margin-left: auto !important;
            margin-right: auto !important;
        }

        .popupLabelText {
            font-size: 8pt;
            font-weight: bold;
        }

        .rspCollapseBarExpand,
        .rspCollapseBarExpandOver {
            background: url("Images/Navvia/splitter_expand_arrow.png") no-repeat 0 0 !important;
            height: 20px !important;
            width: 21px !important;
        }

        .rspCollapseBarCollapse,
        .rspCollapseBarCollapseOver {
            background: url("Images/Navvia/splitter_collapse_arrow.png") no-repeat 0 0 !important;
            height: 20px !important;
            width: 21px !important;
        }
    </style>
    <script type="text/javascript">
        var diagram;
        var palette;
        //var overview;
        var lastDroppedNode;
        var svgData;
        var g_delimiter = String.fromCharCode(007);

        var BusinessRule = 'BusinessRuleIcon';
        var ManualTask = 'ManualTaskIcon';
        var ReceiveTask = 'ReceiveTaskIcon';
        var ScriptTask = 'ScriptTaskIcon';
        var SendTask = 'SendTaskIcon';
        var ServiceTask = 'ServiceTaskIcon';
        var SubProcess = 'SubProcessIcon';
        var UserTask = 'UserTaskIcon';

        var userHandles = [];

        function dropHandler(args) {
            diagram._modified = true;
            if (args.element) {
                if (!args.element.isSwimlane && !args.element.isLane) {
                    var node = args.element;
                    lastDroppedNode = node;
                    if (node.addInfo.DropWidth) {
                        var width = node.addInfo.DropWidth;
                        var height = node.addInfo.DropHeight;
                        diagram.updateNode(node.name, { width: width, height: height });
                    }
                    if (BusinessRule === node.name.substring(0, BusinessRule.length))
                        diagram.updateNode(node.name, { pathData: "M24.917,19.751H12.261v-4.406h12.656V19.751z M24.917,9.876H12.261v4.469h12.656V9.876z M11.261,6.751H6.917 v2.125h4.344V6.751z M24.917,6.751H12.261v2.125h12.656V6.751z M11.261,9.876H6.917v4.469h4.344V9.876z M11.261,15.345H6.917v4.406 h4.344V15.345z M120,5.75v48c0,3.312-2.688,6-6,6H6c-3.313,0-6-2.688-6-6v-48c0-3.313,2.687-6,6-6h108 C117.312-0.25,120,2.437,120,5.75z M25.917,5.751h-20v15h20V5.751z", type: "path" });
                    if (ManualTask === node.name.substring(0, ManualTask.length))
                        diagram.updateNode(node.name, { pathData: "M114-0.25H6c-3.313,0-6,2.687-6,6v48c0,3.312,2.687,6,6,6h108c3.312,0,6-2.688,6-6v-48 C120,2.437,117.312-0.25,114-0.25z M13.465,3c0.701,0,1.268,0.503,1.268,1.124c0,0.62-0.567,1.122-1.268,1.122h-4.52L13.465,3z M24.228,11.407h-9.333l0.225,0.821h7.349c0.699,0,1.269,0.502,1.269,1.123c0,0.62-0.569,1.123-1.269,1.123h-6.735l0.225,0.821 h4.752c0.699,0,1.267,0.501,1.267,1.122c0,0.621-0.567,1.124-1.267,1.124h-4.138h-3.902H9.693c-3.159,0-5.721-2.562-5.721-5.723 c0-3.161,2.562-5.723,5.721-5.723h1.025h2.725h8.833c0.699,0,1.268,0.503,1.268,1.123c0,0.621-0.568,1.123-1.268,1.123h-8.219 l0.225,0.819h9.946c0.7,0,1.268,0.503,1.268,1.124C25.495,10.905,24.928,11.407,24.228,11.407z", type: "path" });
                    if (ReceiveTask === node.name.substring(0, ReceiveTask.length))
                        diagram.updateNode(node.name, { pathData: "M15.208,12.357L7.23,5.917h15.956L15.208,12.357z M24,6.545l-8.792,7.097L6.417,6.545V17H24V6.545z M120,5.75v48c0,3.313-2.687,6-6,6H6c-3.313,0-6-2.687-6-6v-48c0-3.313,2.687-6,6-6h108C117.313-0.25,120,2.437,120,5.75z M25,4.917 H5.417V18H25V4.917z", type: "path" });
                    if (ScriptTask === node.name.substring(0, ScriptTask.length))
                        diagram.updateNode(node.name, { pathData: "M6.601,16.486h8.903v1.012H6.601V16.486z M15.504,13.176H6.601v1.013h8.903V13.176z M15.504,10.212H6.601 v1.013h8.903V10.212z M15.504,6.852H6.601v1.012h8.903V6.852z M120,6v48c0,3.312-2.688,6-6,6H6c-3.313,0-6-2.688-6-6V6 c0-3.313,2.687-6,6-6h108C117.312,0,120,2.687,120,6z M17.231,9.009c0-1.655,2.961-5.922,2.961-5.922H6.871 c0,0-4.441,4.267-4.441,5.922s2.843,4.271,2.961,5.922S2.43,20.853,2.43,20.853h13.324c0,0,4.556-4.271,4.438-5.922 C20.074,13.28,17.231,10.664,17.231,9.009z", type: "path" });
                    if (SendTask === node.name.substring(0, SendTask.length))
                        diagram.updateNode(node.name, { pathData: "M114-0.25H6c-3.313,0-6,2.687-6,6v48c0,3.312,2.687,6,6,6h108c3.312,0,6-2.688,6-6v-48 C120,2.437,117.312-0.25,114-0.25z M23.186,5.917l-7.978,6.44L7.23,5.917H23.186z M24,17H6.417V6.545l8.791,7.097L24,6.545V17z", type: "path" });
                    if (ServiceTask === node.name.substring(0, ServiceTask.length))
                        diagram.updateNode(node.name, { pathData: "M15.416,13.751c0,0.827-0.673,1.5-1.5,1.5s-1.5-0.673-1.5-1.5s0.673-1.5,1.5-1.5 S15.416,12.924,15.416,13.751z M120,5.75v48c0,3.312-2.688,6-6,6H6c-3.313,0-6-2.688-6-6v-48c0-3.313,2.687-6,6-6h108 C117.312-0.25,120,2.437,120,5.75z M23.916,12.442c-2.024-0.719-2.925-2.896-2.003-4.836l-1.852-1.852 C19.544,6,19.009,6.117,18.491,6.117c-1.427,0-2.738-0.881-3.267-2.365h-2.617c-0.527,1.484-1.838,2.365-3.265,2.365 C8.824,6.117,8.29,6,7.773,5.754L5.92,7.605c0.921,1.94,0.02,4.117-2.003,4.836v2.619c2.023,0.719,2.925,2.896,2.003,4.836 l1.853,1.852c0.517-0.247,1.051-0.363,1.57-0.363c1.426,0,2.737,0.88,3.264,2.365h2.617c0.528-1.484,1.839-2.365,3.266-2.365 c0.519,0,1.054,0.117,1.571,0.363l1.852-1.852c-0.922-1.94-0.021-4.117,2.003-4.836V12.442z M22.916,13.091v1.321 c-0.923,0.493-1.631,1.265-2.03,2.226c-0.399,0.962-0.444,2.009-0.14,3.012l-0.934,0.934c-0.432-0.131-0.875-0.197-1.323-0.197 c-1.662,0-3.132,0.908-3.914,2.365h-1.321c-0.781-1.457-2.25-2.365-3.912-2.365c-0.448,0-0.891,0.066-1.322,0.197l-0.935-0.935 c0.304-1.002,0.259-2.049-0.14-3.011c-0.398-0.961-1.106-1.732-2.029-2.226v-1.321c0.923-0.493,1.631-1.265,2.029-2.226 c0.398-0.962,0.444-2.009,0.14-3.011L8.021,6.92c0.431,0.131,0.874,0.197,1.321,0.197c1.662,0,3.132-0.908,3.913-2.365h1.321 c0.782,1.457,2.252,2.365,3.915,2.365c0.448,0,0.891-0.066,1.322-0.197l0.934,0.934c-0.304,1.002-0.259,2.049,0.14,3.011 C21.285,11.826,21.993,12.598,22.916,13.091z M19.993,13.751c0-3.35-2.726-6.075-6.077-6.075c-3.35,0-6.075,2.726-6.075,6.075 c0,3.351,2.725,6.076,6.075,6.076C17.267,19.827,19.993,17.102,19.993,13.751z M18.993,13.751c0,2.799-2.276,5.076-5.077,5.076 c-2.799,0-5.075-2.277-5.075-5.076c0-2.798,2.276-5.075,5.075-5.075C16.716,8.676,18.993,10.953,18.993,13.751z M16.416,13.751 c0-1.38-1.119-2.5-2.5-2.5c-1.381,0-2.5,1.12-2.5,2.5s1.119,2.5,2.5,2.5C15.297,16.251,16.416,15.132,16.416,13.751z", type: "path" });
                    if (SubProcess === node.name.substring(0, SubProcess.length))
                        diagram.updateNode(node.name, { pathData: "M114-0.25H6c-3.313,0-6,2.687-6,6v48c0,3.312,2.687,6,6,6h108c3.312,0,6-2.688,6-6v-48 C120,2.437,117.312-0.25,114-0.25z M66.918,48.848h-6.162v6.28h-1.509V48.85h-6.165v-1.509h6.165v-6.153h1.509v6.15h6.162V48.848z", type: "path" });
                    if (UserTask === node.name.substring(0, UserTask.length))
                        diagram.updateNode(node.name, { pathData: "M114-0.25H6c-3.313,0-6,2.687-6,6v48c0,3.312,2.687,6,6,6h108c3.312,0,6-2.688,6-6v-48 C120,2.437,117.312-0.25,114-0.25z M9.055,2.724c2.696,0,4.883,2.187,4.883,4.883c0,2.697-2.187,4.882-4.883,4.882 s-4.883-2.186-4.883-4.882C4.172,4.91,6.359,2.724,9.055,2.724z M2.544,19c0,0,0.049-4.381,3.232-5.801 c0.967,0.569,2.077,0.918,3.278,0.918c1.201,0,2.312-0.349,3.278-0.918C15.517,14.619,15.565,19,15.565,19H2.544z", type: "path" });
                    if (node.addInfo.NodeType)
                        if (node.addInfo.NodeType == 'Task') {
                            createNewTask(node);
                        }
                } else {
                    if (args.element && args.element.isSwimlane) {
                        if (args.element.orientation == "horizontal") {
                            args.element.minHeight = 120;
                            args.element.minWidth = 750;
                        }
                        if (args.element.orientation == "vertical") {
                            args.element.minHeight = 750;
                            args.element.minWidth = 120;
                        }
                        diagram.updateNode(args.element.name, {});
                    }
                    if (args.element && args.element.isLane) {
                        if (args.element.orientation == "horizontal") {
                            args.element.height = 120;
                            args.element.width = 750;
                        }
                        if (args.element.orientation == "vertical") {
                            args.element.height = 750;
                            args.element.width = 120;
                        }
                        diagram.updateNode(args.element.name, {});
                    }
                }
            }
        }

        function nodecollectionchangeHandler(args) {
            if (args) {
                var node = args.element;
                if (args.element && args.element.isSwimlane) {
                    if (args.element.orientation == "horizontal") {
                        args.element.minHeight = 120;
                        args.element.minWidth = 750;
                        args.element.maxWidth = Number.POSITIVE_INFINITY;  // Workaround provided by SF to address lane resizing by itself issue (doesn't work) - 02Feb2015
                        args.element.maxHeight = Number.POSITIVE_INFINITY;
                    }
                    if (args.element.orientation == "vertical") {
                        args.element.minHeight = 750;
                        args.element.minWidth = 120;
                        args.element.maxWidth = Number.POSITIVE_INFINITY;
                        args.element.maxHeight = Number.POSITIVE_INFINITY;
                    }
                }
                if (args.element.constraints & ej.datavisualization.Diagram.NodeConstraints.Connect) {
                    args.element.constraints = ej.datavisualization.Diagram.NodeConstraints.Default ^ ej.datavisualization.Diagram.NodeConstraints.Connect;

                    if (args.element.shape) {
                        if (args.element.type == "text") {
                            if (args.element.height < 35) {
                                args.element.height = 35;
                            }
                            args.element.fillColor = "Transparent"; // Try setting to white - connector label????
                        }
                    }
                }
            }
        }

        function nodeTextChange(args) {
            //alert('In nodeTextChange');
            if (args.element) {
                if (!args.element.isSwimlane) {
                    var node = args.element;
                    if (node.addInfo.NodeType == 'Task') {
                        //console.log('>> Text change for node.name = ' + node.name + '  addInfo = ' + node.addInfo.NodeDatabaseID + '  args.value = ' + args.value);
                        updateTaskName(node.addInfo.NodeDatabaseID, args.value);
                    }
                }
            }
        }

        function updateTaskName(taskID, taskName) {
            // DiagramWebServices.UpdateTaskName(taskID, taskName, OnSuccess_UpdateTask, OnFail);
        }

        function OnSuccess_UpdateTask(response) {
            if (response != 'Successful')
                alert(response);
            else {
                //console.log('Task updated');
                UpdateDiagram(); // Want to keep the diagram in sync with any database changes
            }
        }

        function UpdateDiagram() {
            //if (diagram._modified) {
            if (true) {
                var key = "";
                var diagramData = diagram.save();
                diagramData = JSON.stringify(diagramData);
                var options = {
                    //Name of the exported file
                    //fileName: "diagram",
                    //Specifies whether to export as files/data
                    //mode: "download",
                    mode: "data",
                    //Specifies the region to be exported
                    region: "pageSettings",
                    //Format of the exported file
                    format: "png",
                    //Can be set as a rectangle {x,y width, height}
                    //bounds: { x: 0, y: 0 },
                    //margin to the exported file/data
                    //margin: { left: 30 }
                };
                var imageData = diagram.exportDiagram(options);

                this.OnSuccess_Update();
            }
        }

        function OnSuccess_Update(response) {
            diagram._modified = false;

        }



        function createNewTask(node) {
            this.OnSuccess_CreateTask(node);
        }

        function OnSuccess_CreateTask(node) {
            var curr_addInfo = node.addInfo;  // Get the current node properties
            var extra_addInfo = { 'NodeDatabaseID': "", 'Sequence': "" };  // Add (or replace) this property
            var result = $.extend({}, curr_addInfo, extra_addInfo); // Merge the 2 arrays
            node.addInfo = result; // Place the result back in the addInfo property of the node
            //console.log('>> Return from creating a task for node.name = ' + node.name + '  node.addInfo.NodeType = ' + node.addInfo.NodeType + '  node.addInfo.NodeDatabaseID = ' + node.addInfo.NodeDatabaseID + '  response = ' + response);
            UpdateDiagram(); // Keep diagram in sync with database update
        }

        $(window).load(function () {
            diagram = $("#DiagramContent").ejDiagram("instance");
        });
    </script>
</head>
<body style="height: 1000px; width: 1200px">
    <form id="form1" runat="server">
        <asp:ScriptManager ID="scriptManager1" runat="server"></asp:ScriptManager>

        <div style="height: 100%; width: 100%">
            <div id="divPalette" runat="server" onmouseup="" style="float: left">

                <ej:SymbolPalette ID="symbolpalette" runat="server" ClientIDMode="Static">
                </ej:SymbolPalette>
            </div>
            <div style="float: left; padding: 5px; background-color: gray; width: 800px; height: 100%">
                <ej:Diagram ID="DiagramContent" runat="server" Height="100%" Width="100%" OnClientDrop="dropHandler" OnClientNodeCollectionChange="nodecollectionchangeHandler"
                    OnClientSelectionChange="selectionChangeHandler" ClientIDMode="Static" OnClientTextChange="nodeTextChange">
                </ej:Diagram>
            </div>
        </div>
        <input type="button" value="lineTool" onclick="activateTool(this)" />
        <input type="button" value="deActivateTool" onclick="deActivateTool(this)" />
    </form>

</body>
<script>

    function propertyChange(args) {
        console.log("propertyChange")
    }
    function activateTool(evt) {

        $("#DiagramContent").ejDiagram("instance").activateTool("orthogonalLine");
    }
    function deActivateTool() {
        $("#DiagramContent").ejDiagram("instance").deactivateTool();
    }
    function ConnectorCollectionChange(args) {
        if (args.element && args.element.labels.length === 0) {
            args.element.labels.push(ej.datavisualization.Diagram.Label({
                name: ej.datavisualization.Diagram.Util.randomId(),
                text: "New Label"
            }))
        }
    }
    $(window).load(function () {
        var paletteItems = $(".e-paletteItem");
        for (m = 0; m < paletteItems.length; m++) {
            paletteItems[m].setAttribute("title", ((paletteItems[m].id).split("_")[0]));
        }
    });

    function nodeCollectionChange(args) {
        if (args.element && args.element.isSwimlane)
            args.element.lanes[0].header.wrapping = ej.datavisualization.Diagram.TextWrapping.NoWrap;
    }
    function dragEnter(args) {
        if (args) {
            var diagram = $("#DiagramContent").ejDiagram("instance");
            if (args.element && args.element.isLane) {
                if (args.element.orientation == "horizontal") {
                    args.element.minHeight = 220;
                    args.element.minWidth = 350;
                }
                if (args.element.orientation == "vertical") {
                    args.element.minHeight = 350;
                    args.element.minWidth = 220;
                }
                var header = diagram.findNode(args.element.children[0]);
                if (header) {
                    header.labels[0].text = "Process Manager and manager"
                    header.labels[0].wrapping = ej.datavisualization.Diagram.TextWrapping.NoWrap;
                }
            }
        }
    }
</script>
</html>
